#include <tunables/global>

%HOME%%USERNAME%/usr/lib/node_modules/npm/bin/npm-cli.js {

deny %HOME%%USERNAME%/usr/** wl,
deny %HOME%%USERNAME%/bin/** wl,
    deny %HOME%%USERNAME%/proc/** wl,
    deny %HOME%%USERNAME%/lib/** wl,
    deny %HOME%%USERNAME%/lib64/** wl,

deny %HOME%%USERNAME%/.ssh/** rwl,
deny %HOME%%USERNAME%/.gnupg/** rwl,

  signal receive set=hup peer=%HOME%%USERNAME%/bin/bash,
  signal receive set=hup peer=%HOME%%USERNAME%/usr/lib/node_modules/npm/bin/npm-cli.js,
  signal receive set=abrt peer=%HOME%%USERNAME%/usr/lib/node_modules/npm/bin/npm-cli.js,
    signal receive set=int peer=%HOME%%USERNAME%/usr/lib/node_modules/npm/bin/npm-cli.js,
  signal receive set=hup peer=/usr/bin/nodejs_%USERNAME%,
  signal receive set=int peer=%HOME%%USERNAME%/usr/bin/node,
  signal receive set=int peer=/usr/bin/nodejs_%USERNAME%,
  signal receive set=kill peer=/usr/bin/nodejs_%USERNAME%,
  signal receive set=quit peer=/usr/bin/nodejs_%USERNAME%,
  signal receive set=rtmin+1 peer=/usr/bin/nodejs_%USERNAME%,
  signal receive set=term peer=/usr/bin/nodejs_%USERNAME%,
  
  signal send set=hup peer=%HOME%%USERNAME%/usr/lib/node_modules/npm/bin/npm-cli.js,
  signal send set=abrt peer=%HOME%%USERNAME%/usr/lib/node_modules/npm/bin/npm-cli.js,
    signal send set=int peer=%HOME%%USERNAME%/usr/lib/node_modules/npm/bin/npm-cli.js,
  signal send set=int peer=%HOME%%USERNAME%/usr/bin/node,
  signal send set=rtmin+1 peer=%HOME%%USERNAME%/usr/bin/node,
  
  deny capability dac_override,
  deny capability dac_read_search,


  network,

    /lib/** r,
  /usr/lib/** r,
  /run/resolvconf/resolv.conf r,

%HOME%%USERNAME%/ r,
    %HOME%%USERNAME%/** mr,
    owner %HOME%%USERNAME%/** wl,

# /dev/null is often used
%HOME%%USERNAME%/dev/null rw,

%HOME%%USERNAME%/bin/sh ix,
    %HOME%%USERNAME%/bin/dash ix,

  %HOME%%USERNAME%/usr/bin/node ix,
    %HOME%%USERNAME%/usr/bin/git Px,

# npm can spawn scripts
%HOME%%USERNAME%/** Cx -> scripts,

# this profile should be more restrictive, otherwise put the bin as ix above
    profile scripts {
    deny %HOME%%USERNAME%/usr/** wl,
    deny %HOME%%USERNAME%/bin/** wl,
    deny %HOME%%USERNAME%/proc/** wl,
    deny %HOME%%USERNAME%/lib/** wl,
    deny %HOME%%USERNAME%/lib64/** wl,
    
deny %HOME%%USERNAME%/.ssh/** rwl,
deny %HOME%%USERNAME%/.gnupg/** rwl,

    # Restrict network access! Only allow unix sockets
    network unix,
    
    %HOME%%USERNAME%/ r,
    %HOME%%USERNAME%/** mr,
    owner %HOME%%USERNAME%/** rwl,
    
    # /dev/null is often used
    %HOME%%USERNAME%/dev/null rw,
    
    # Connecting to mySQL
    /run/mysqld/mysqld.sock rw,
    
    # bins that have their own profile
    %HOME%%USERNAME%/usr/bin/hg Px,
    %HOME%%USERNAME%/usr/bin/git Px,
    %HOME%%USERNAME%/usr/bin/node Px,
    %HOME%%USERNAME%/usr/bin/bash Px,
    %HOME%%USERNAME%/usr/bin/python Px,
    %HOME%%USERNAME%/usr/lib/node_modules/npm/bin/npm-cli.js Px,
    %HOME%%USERNAME%/usr/lib/node_modules/npm/bin/npx-cli.js Px,
    
    # Scripts of scripts
    %HOME%%USERNAME%/** ix,

    }


}
